# Poco

# class Mutex

Library: Foundation
Package: Threading
Header: Poco/Mutex.h

## Description

A Mutex (mutual exclusion) is a synchronization mechanism used to control access to a shared resource in a concurrent (multithreaded) scenario. Mutexes are recursive, that is, the same mutex can be locked multiple times by the same thread (but, of course, not by other threads). Using the ScopedLock class is the preferred way to automatically lock and unlock a mutex.

## Inheritance

Direct Base Classes: MutexImpl

All Base Classes: MutexImpl

## Member Summary

Member Functions: lock, tryLock, unlock

## Types

### ScopedLock

typedef Poco::ScopedLock < Mutex > ScopedLock;

## Constructors

### Mutex

Mutex();

creates the Mutex.

## Destructor

### ~Mutex

~Mutex();

destroys the Mutex.

## Member Functions

### lock

void lock();

Locks the mutex. Blocks if the mutex is held by another thread.

### lock

void lock(
long milliseconds
);

Locks the mutex. Blocks up to the given number of milliseconds if the mutex is held by another thread. Throws a TimeoutException if the mutex can not be locked within the given timeout.

Performance Note: On most platforms (including Windows), this member function is implemented using a loop calling (the equivalent of) tryLock() and Thread::sleep(). On POSIX platforms that support pthread_mutex_timedlock(), this is used.

### tryLock

bool tryLock();

Tries to lock the mutex. Returns false immediately if the mutex is already held by another thread. Returns true if the mutex was successfully locked.

### tryLock

bool tryLock(
long milliseconds
);

Locks the mutex. Blocks up to the given number of milliseconds if the mutex is held by another thread. Returns true if the mutex was successfully locked.

Performance Note: On most platforms (including Windows), this member function is implemented using a loop calling (the equivalent of) tryLock() and Thread::sleep(). On POSIX platforms that support pthread_mutex_timedlock(), this is used.

### unlock

void unlock();

Unlocks the mutex so that it can be acquired by other threads.